/*  $Id: CLex_test.cc,v 1.5 1999/06/20 17:10:35 shaggy Exp $
 *      relative path: lib/cparse
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#pragma Make Includes_Banned += -nostdinc -nostdinc++
#pragma Make Flags_Banned += -static


#include <sys/types.h>
#include <unistd.h>
#include <cstdlib>
#include <cstdio>
#include <cstring>

#include <CLex>

main(int argc, csz **argv)
{
	int bufsize = 4096;
	int n;
	CLex::Token token, last;
	bool print_tokens = false;
	char strbuf[4096];
	char bufbuf[4096];
	char namebuf[1024];

	if(argc > 1)
		bufsize = atoi(argv[1]);
	if(bufsize < 0) {
		bufsize = -bufsize;
		print_tokens = true;
	}
	CLex lex(strbuf, sizeof(strbuf));
	lex.set_buf(bufbuf, sizeof(bufbuf));
	lex.set_name(namebuf, sizeof(namebuf));
	lex.parse_keywords();
	lex.parse_cpp(false);
	lex.parse_eol();
	lex.parse_indent();
	char buf[bufsize];
	last = CLex::NONE;
	while((n = read(0, buf, bufsize)) > 0) {
		lex.set_src(buf, n);
		while((token = lex.next_token()) != CLex::NONE
				&& token != CLex::INCOMPLETE) {
			if(print_tokens) {
				printf("%s:%d: %d (%s)",
					lex.source(), lex.line_num(),
					token, lex.token_string(token));
				if(token != CLex::EOL)
					printf(": (%s)\n", lex.token_string());
				else
					printf("\n");
			} else {
				printf("%s%s", lex.token_spacing(last, token),
					lex.token_string());
			}
			last = token;
		}
	}	
	fflush(stdout);
}

