/*  $Id: CParse.hh,v 1.22 1999/07/16 20:18:49 shaggy Exp $
 *      C/C++ Parser
 *      relative path: .//lib/cparse
 */ 

#ifndef __CParse_hh__
#define __CParse_hh__

#define CParse_VERSION_MAJOR	0
#define CParse_VERSION_MINOR	1
#define CParse_VERSION_STRING	"0.01" 

#include <CLex>
#include <vCAction>
#include <TokenList>


class ActionStack;


class CParse {
public:
	typedef vCAction::Item Item;
	typedef const vCAction::Item &Item_;
private:
	CLex *_clex;
	Item _next_yylval;
	Item _nextnext_yylval;
	short _next_yychar;
	short _nextnext_yychar;
	short _prev_yychar;
	bool _havenext;
	bool _havenextnext;
	bool _debug;
	TokenList *_toksrc;	/* tokens to use as input */
	int _saveline;
protected:	/* so auto-generated parser can access them */
	vCAction *_caction;
	bool _yydebug;
	Item _current_scope;
	Item _enum_val, _enum_type;
	Item _stmtlist;
	bool _savecode;
	bool _gsavecode; /* global savecode variable */
	bool _rawid;	/* if true, don't preprocess ID's for scoping, etc */
	TokenList *_deftok;	/* deferred tokens */
public:
	CParse(CLex &clex, vCAction &caction);
	int parse();
	bool debug() { return _debug; }
	void debug(bool d = true) { _debug = d; }
	bool yydebug() { return _yydebug; }
	void yydebug(bool d = true) { _yydebug = d; }
	void savecode(bool b = true) { _gsavecode = _savecode = b; }
	void inject(TokenList *tok);

#ifdef IMPLEMENTATION_CParse
private:
	int _do_parse();
	int _lex(Item *yylval);
	static void _internal_error(vErrorReport *er,
						csz *file, int line);

protected:	/* so auto-generated parser can access them */
	int _peekahead_lex(Item *yylval);
	void _warn_unused_type(Item_ t);
	void newdecl(Item*, Item_);

#define T(x)	vCAction::x
#define A(x)	vCAction::x

#define INTERNAL_ERROR CParse::_internal_error(_caction, __FILE__, __LINE__)

// *Sigh*... if only cpp macros supported variable #'s of arguments...

#define do(r,a) _caction->a(&r,none,none,none)
#define do1(r,a,p1) _caction->a(&r,p1,none,none)
#define do2(r,a,p1,p2) _caction->a(&r,p1,p2,none)
#define do3(r,a,p1,p2,p3) _caction->a(&r,p1,p2,p3)

#define none vCAction::none


#endif

};

#endif
