/*  $Id: TokenList.cc,v 1.9 1999/07/16 20:18:49 shaggy Exp $
 *      Token list
 *      
 *      relative path: lib/cparse
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <libc.h>
#include <stdx1.h>
#include <defines>
#include <ldefines>
#include <vCAction>
#include "TokenList.hh"


TokenList::~TokenList()
{
	Item v;
	while(next(&v))
		;
}

int
TokenList::next(Item *r)
{	
	Node *n;
	if(!(n = _first))
		return 0;
	_first = n->next;
	*r = n->item;
	delete n;
	return r->token;
}

void
TokenList::append(Item_ v)
{
	Node *n = new Node;
	n->item = v;
	n->next = 0;
	if(_last) 
		_last->next = n;
	else 
		_first = n;
	_last = n;
}

void
TokenList::prepend(Item_ v)
{
	Node *n = new Node;
	n->item = v;
	n->next = _first;
	_first = n;
	if(!_last)
		_last = n;
}

void
TokenList::append_delete(TokenList *t)
{
	if(_last) 
		_last->next = t->_first;
	else 
		_first = _last = t->_first;
	if(t->_last)
		_last = t->_last;
	t->_first = t->_last = 0;
	delete t;
}

