/*  $Id: _stdio_file.h,v 1.2 1999/07/16 20:18:50 shaggy Exp $
 *      relative path: ./lib/posix
 */

typedef struct _FILE FILE;

typedef _fpos_t fpos_t;

extern FILE *_stdfile[];

#define stdin	_stdfile[0]
#define stdout	_stdfile[1]
#define stderr	_stdfile[2]

#define BUFSIZ		8192
#define FILENAME_MAX	4095
#define FOPEN_MAX	256
#define L_tmpnam	19
#define TMP_MAX		26
#define _IOFBF		0
#define _IOLBF		1
#define _IONBF		2

#ifndef SEEK_SET
#	define SEEK_SET	0
#	define SEEK_CUR	1
#	define SEEK_END	2
#endif

int remove(const char *filename);
int rename(const char *from, const char *to);
FILE *tmpfile(void);
char *tmpnam(char *s);
int fclose(FILE *f);
int fflush(FILE *f);
FILE *fopen(const char *name, const char *mode);
FILE *freopen(const char *name, const char *mode, FILE *f);
void setbuf(FILE *f, char *buf);
int setvbuf(FILE *f, char *buf, int mode, size_t len);
int fprintf(FILE *f, const char *fmt, ...);
int fscanf(FILE *f, const char *fmt, ...);
int vfprintf(FILE *f, const char *fmt, _va_list arg);
int fgetc(FILE *f);
char *fgets(char *s, int n, FILE *f);
int fputc(int c, FILE *f);
int fputs(const char *s, FILE *f);
int getc(FILE *f);
int putc(int c, FILE *f);
int ungetc(int c, FILE *f);
size_t fread(void *p, size_t size, size_t n, FILE *f);
size_t fwrite(const char *p, size_t size, int n, FILE *f);
int fgetpos(FILE *f, fpos_t *pos);
int fseek(FILE *f, long ofs, int whence);
int fsetpos(FILE *f, const fpos_t *pos);
long ftell(FILE *f);
void rewind(FILE *f);
void clearerr(FILE *f);
int feof(FILE *f);
int ferror(FILE *f);

#ifdef _POSIX_SOURCE

#define L_ctermid	_L_ctermid
#define L_cuserid	_L_cuserid

#ifndef STREAM_MAX
#	define STREAM_MAX	FOPEN_MAX
#endif

FILE *fdopen(int fildes, const char *type);
int fileno(FILE *stream);

#endif
