/*  $Id: strtok.cc,v 1.8 1999/07/16 20:18:50 shaggy Exp $
 *      
 *      strtok() string tokenizing function
 *      
 *      relative path: lib/posix
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <stdx1.h>
#include "string.h"


sz*
strtok(sz *s, csz *delim)
{
	static sz *sp = 0;	/* not thread-safe */

	if(s)
		sp = s;
	while(*sp && strchr(delim, *sp))
		sp++;
	if(!*sp)
		return 0;
	char *first = sp;
	while(*sp && !strchr(delim, *sp))
		sp++;
	if(*sp)
		*sp++ = 0;
	return first;
}

