/*  $Id: vSymTab.hh,v 1.10 1999/07/16 20:18:51 shaggy Exp $
 *      Symbol Table support
 *      relative path: ./lib/symtab
 */     

#ifndef __vSymTab_hh__
#define __vSymTab_hh__

#include <stdx1.h>
#include <defines>
//#include <Object>

// just a linked-list for now, although this needs to be changed
// in the future for efficiency

class vSymTab {
public:
	typedef vStrTab::Id Id;
	typedef void *Val;

	virtual ~vSymTab() {}
	virtual bool get(Id id, Val &val) const = 0;
	virtual bool set(Id id, Val val) = 0;
	virtual bool add(Id id, Val val) = 0;
	virtual bool del(Id id) = 0;
	virtual vSymTab* parent() const = 0;
	virtual bool parent(vSymTab*) = 0;	
	virtual void* data() const = 0;
	virtual bool data(void*) = 0;	
	virtual vStrTab* strtab() const = 0;
	virtual Id index(uint n) const = 0;
	virtual vSymTab* transplant() = 0;

	Val get(Id id) const { Val v; return get(id, v) ? v : 0; }
};
typedef const vSymTab &vSymTab_;

#if 0
extern obj_t Type_vSymTab;

class obj_vSymTab : public Object {
public:
};
#endif

#endif
