#include <dcobj>
#include "t_circle.dh.h"
#include "t_ellipse.dh.h"
#include "D_Circle.dh.h"
#include "D_Ellipse.dh.h"
#include <stdio.h>

void
print_area(r_circle c)
{
	printf("getting radius\n");
	int radius = c.radius();
	printf("got radius\n");
	int area = c.area();
	printf("r=%d area=%d (%d)\n", radius, area, 3*radius*radius);
}

void
print_area_e(r_ellipse e)
{
	int m1 = e.major();
	int m2 = e.minor();
	printf("a=%d b=%d area=%d\n", m1, m2, 3*m1*m2/4);
}

void
set_radius(w_circle c, int radius)
{
	c.radius(radius);
}


void
test2()
{
	Ellipse q(7,7);
	Ellipse q2(12, 12);
	Ellipse q3(3, 4);
	D_Ellipse a(q2);
	D_Ellipse b(q3);
	Circle c1(6);
	D_Circle c(&c1);
	D_Circle d(8);
	D_Circle e(c1);

	r_circle rc = c;
	printf("radius=%d %d\n", c1.radius(), rc.radius());
	print_area(rc);
	print_area_e(D_Ellipse(q));

	D_Ellipse test(q);
	print_area_e(test);
	set_radius(test, 8);
	print_area_e(test);

	if(DCBIND(r_circle, c, a)) {
		print_area(c);
	} else printf("dbind1 failed\n");

	if(DCBIND(r_circle, c, b))
		print_area(c);
	else printf("dbind2 failed\n");

	r_ellipse q8 = a;
	if(DCBIND(r_circle, c, q8))
		print_area(c);
	else printf("dbind3 failed\n");
	
}

int
main()
{
	test2();
}

