# 1 "drv/tty.c"
 












































# 1 "include/sys/types.h" 1
 








































 












typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned long	ulong;
typedef unsigned int	uint;
typedef unsigned char	boolean;
typedef void		(*void_fptr)(void);
typedef int		(*int_fptr)(void);
typedef char		*(*str_fptr)(void);
typedef int		(*main_fptr)(int argc, char **argv);
typedef unsigned long	vaddr;
typedef unsigned long	paddr;
typedef unsigned char	lock_t;
typedef	ulong		obj_t;
typedef ulong		status_t;
typedef obj_t		label_t;

 

typedef ushort		wchar_t;

typedef ushort		dev_t;
typedef ulong		ino_t;
typedef ushort		mode_t;
typedef ushort		nlink_t;
typedef long		off_t;
typedef ulong		pid_t;
typedef ushort		uid_t;
typedef ushort		gid_t;

typedef long		time_t;
typedef	long		clock_t;




typedef uint		size_t;




typedef long		ssize_t;




typedef long int	ptrdiff_t;








# 46 "drv/tty.c" 2

# 1 "include/sys/resource.h" 1
 















































# 1 "include/stddef.h" 1
 





























































# 49 "include/sys/resource.h" 2

# 1 "include/object.h" 1
 
















































 
typedef struct obj_frame {
	obj_t	self;
	obj_t	op;	
	obj_t	oid;
	obj_t	next;
	void	*data;
	ulong	size;
} ObjFrame;



typedef obj_t (*obj_method)(ObjFrame *frame, void *data, obj_t arg1, obj_t arg2, obj_t arg3);


 
typedef struct attr_table {
	label_t	*id;		 
	ushort	value;		 
	uchar	type;	
} AttrTable;	


 
typedef struct method_table {
	label_t	   *id;		 
	obj_method func;	 
} MethodTable; 


 
typedef struct obj_class {
	MethodTable	*method;
	AttrTable	*attr;
	ushort		nmethod;
	ushort		nattr;
} ObjClass;


# 98 "include/object.h"

















 








 




 




























 






















extern label_t _init, _new, _free, _eval, _dup, _type;
extern label_t _class, _next, _prev;
extern label_t _get, _set, _getattr, _create, _remove;
extern label_t _read, _write, _readat, _writeat;
extern label_t _devread, _devwrite;
extern label_t _mem_alloc, _mem_free;
extern label_t _vm_alloc, _vm_free, _vm_map, _vm_reserve, _vm_share;

extern obj_t ObjCall(obj_t oid, obj_t op, obj_t arg1, obj_t arg2, obj_t arg3);
extern obj_t ObjCall_Trap(obj_t oid, obj_t op, obj_t arg1, obj_t arg2, obj_t arg3);
extern obj_t ObjCall_Self(obj_t oid, obj_t op, obj_t arg1,obj_t arg2,obj_t arg3, obj_t self);
extern ulong AttrLookup(AttrTable *table, obj_t id);
extern obj_t AttrGet(void *data, AttrTable *table, int tsize, obj_t id);
extern obj_t AttrSet(void *data, AttrTable *table, int tsize, obj_t id, obj_t val);
extern obj_t Label(char *str);
extern obj_t LabelRegister(char *str, obj_t value, obj_t clss);
extern obj_t LabelClassify(obj_t id, obj_t clss);
extern obj_t ObjString(char *buf, int len, obj_t id);
extern void obj_print(obj_t oid);

extern obj_t Main(ObjFrame *frame, vaddr base, obj_t arg, obj_t env);




 






# 50 "include/sys/resource.h" 2

# 1 "include/sys/param.h" 1
 




















































# 1 "I386/mdparam.h" 1
 













































 







 



 










 














 















# 54 "include/sys/param.h" 2





























# 51 "include/sys/resource.h" 2

# 1 "include/string.h" 1
 
















































extern void *memchr(const void *s, int c, size_t n);
extern int memcmp(const void *s1, const void *s2, size_t n);
extern void *memcpy(void *s1, const void *s2, size_t n);
extern void *memmove(void *s1, const void *s2, size_t n);
extern void *memset(void *s, uchar c, size_t n);
extern void *memset_w(void *s, ushort c, size_t n);
extern void *memset_l(void *s, ulong c, size_t n);
extern char *strcat(char *s1, const char *s2);
extern char *strchr(const char *s, int c);
extern int strcmp(const char *s1, const char *s2);
extern int strcoll(const char *s1, const char *s2);
extern char *strcpy(char *s1, const char *s2);
extern size_t strcspn(const char *s1, const char *s2);
extern char *strerror(ulong errnum);
extern size_t strlen(const char *s);
extern char *strncat(char *s1, const char *s2, size_t n);
extern int strncmp(const char *s1, const char *s2, size_t n);
extern char *strncpy(char *s1, const char *s2, size_t n);
extern char *strpbrk(const char *s1, const char *s2);
extern char *strrchr(const char *s, int c);
extern size_t strspn(const char *s1, const char *s2);
extern char *strstr(const char *s1, const char *s2);
extern char *strtok(char *s1, const char *s2);
extern size_t strxfrm(char *s1, const char *s2, size_t n);



# 52 "include/sys/resource.h" 2

# 1 "include/macro.h" 1
 

































































# 53 "include/sys/resource.h" 2

# 1 "I386/mdresource.h" 1
 












































# 1 "I386/mdmacro.h" 1
 















































# 1 "I386/port.h" 1
 













































 

 


















 
















 






 





 





# 49 "I386/mdmacro.h" 2















 









 

static void out_portb(uchar v, ushort p) {
	__asm__("outb %%al,%%dx": :"a"(v),"d"(p)); }

static void out_portw(ushort v, ushort p) {
	__asm__("outb %%al,%%dx; movb %%ah,%%al; 	incw %%dx; outb %%al,%%dx": :"a"(v),"d"(p)); }


static void out_regb(uchar r, uchar v, ushort p) {
	__asm__("outb %%al,%%dx; movb %0,%%al; 	incw %%dx; outb %%al,%%dx": :"g"(v),"a"(r),"d"(p)); }


static void out_regw(uchar r, ushort v, ushort p) {
	__asm__("movb %%al,%%ah; incb %%ah; outb %%al,%%dx; 	movb %%ch,%%al; incw %%dx; outb %%al,%%dx; 	movb %%ah,%%al; decw %%dx; outb %%al,%%dx; 	movb %%cl,%%al; incw %%dx; outb %%al,%%dx" 	: :"c"(v),"a"(r),"d"(p)); }





static uchar in_portb(ushort p) {
volatile uchar v;
	__asm__("inb %%dx,%%al":"a="(v):"d"(p));
	return((uchar)v); }

static ushort in_portw(ushort p) {
volatile ushort v;
	__asm__("inw %%dx,%%ax":"a="(v):"d"(p));
	return((ushort)v); }

static uchar in_regb(uchar r, ushort p) {
uchar v;
	__asm__("outb %%al,%%dx; incw %%dx; inb %%dx,%%al"		:"a="(v):"d"(p),"a"(r));

	return((uchar)v); }

static ushort in_regw(uchar r, ushort p) {
volatile ushort v;
	__asm__("movb %%al,%%ah; incb %%ah; outb %%al,%%dx;		incw %%dx; inb %%dx,%%al; movb %%al,%%ch;		decw %%dx; movb %%ah,%%al; outb %%al,%%dx;		incw %%dx; inb %%dx,%%al; movb %%al,%%cl"		:"c="(v):"d"(p),"a"(r));




	return((ushort)v); }

static ushort cmos_read(uchar a) {
	return(in_regb(a,0x70 )); }

static void cmos_write(uchar v, uchar a) {
	out_regb(a,v,0x70 ); }





# 46 "I386/mdresource.h" 2

# 1 "I386/segment.h" 1
 















































typedef struct {
	ulong	lo;
	ulong	hi;
} IDTentry;

typedef struct {
	ulong	lo;
	ulong	hi;
} GDTentry;
































 















































# 47 "I386/mdresource.h" 2

# 1 "I386/vmem.h" 1
 


















































typedef ulong	pte_t;






typedef struct vmseg {
	ulong	start;	
	ushort	size;
	ushort	type;
	struct vmap *vmshare;
	union {
		struct vmap *vmap;
		obj_t	obj;
	} src;
	ulong	index;
	struct vmseg *nextseg;
	struct vmseg *nextshare;
} VmSeg;

typedef struct vmap {
	pte_t	*pte;		 
	long	ptlen;		 
	vaddr	vbase;		 
	VmSeg	*seg;		 
	VmSeg	*share;		 
	lock_t	lock;		 
} Vmap;




 











					 

 










 

 



 




























 









# 48 "I386/mdresource.h" 2

# 1 "I386/context.h" 1
 














































typedef unsigned short segment;

 
typedef struct {
	vaddr	esp;	 
	segment	ss;	 
	ushort	pad;	
} Stack;

typedef struct {
	 
	ushort	link;	 
	ushort	pad1;	
	Stack	sp[3];	 
	paddr	pdbr;	 
	vaddr	pc;	 
	ulong	eflags;	 
	ulong	reg[8];	 
	segment	seg[12]; 	
	segment	ldt;	 
	ushort	pad8;
	ushort	debug;	 
	ushort	iomap;	 
	 
	vaddr	pagedir;  
	vaddr	usp;	  
} Context;



 






 









 









# 49 "I386/mdresource.h" 2


typedef void intr(int param, int irq);


# 120 "I386/mdresource.h"


# 135 "I386/mdresource.h"




# 54 "include/sys/resource.h" 2



 

typedef struct queue {
	struct queue *next;
	struct queue *prev;
} Queue;


typedef void *ZoneP;


 

typedef struct event {
	struct event *next;
	struct event *prev;
        ulong   event;           
        ulong   param;           
        obj_t   sender;          
	obj_t	receiver;	 
	ulong	time;		 
        ulong   aux1;		 
        ulong   aux2;
        ulong   aux3;
        ulong   aux4;
} Event;



# 316 "include/sys/resource.h"



 
extern void nuke_fs(void);
extern void load_average(void);
extern void sys_stat(void);




# 47 "drv/tty.c" 2

# 1 "include/error.h" 1
 



















































 



 





 


 



 








 


 




# 48 "drv/tty.c" 2

# 1 "include/stdio.h" 1
 















































# 1 "include/fcntl.h" 1
 










































































struct flock {
	short	l_type;
	short	l_whence;
	off_t	l_start;
	off_t	l_len;
	pid_t	l_pid;
};


extern obj_t open(char *path, int oflag, ...);
extern obj_t creat(char *path, int mode);
// extern status_t close(obj_t fd);
// extern off_t lseek(obj_t fd, off_t offset, int whence);
extern obj_t dup(obj_t fd);
extern obj_t dup2(obj_t fd, obj_t fd2);
extern obj_t fcntl(obj_t fd, int cmd, ...);



# 49 "include/stdio.h" 2

# 1 "include/stdarg.h" 1
 
















































typedef ulong	*va_list;











# 50 "include/stdio.h" 2


typedef ulong fpos_t;

typedef struct {
	obj_t	fd;
	fpos_t	pos;
} FILE;

extern FILE _stdfile[];















extern int voprintf(obj_t oid, char *fmt, va_list args);
extern int oprintf(obj_t oid, char *fmt, ...);
extern int cprintf(char *fmt, ...);
extern int printf(char *fmt, ...);
extern int kprintf(char *fmt, ...);
extern int vkprintf(char *fmt, va_list args);
extern int eprintf(char *fmt, ...);
extern int vprintf(char *fmt, va_list args);
extern int vsprintf(char *s, char *fmt, va_list args);
extern int sprintf(char *s, char *fmt, ...);
extern int puts(char *s);
extern int putchar(char ch);
extern int getchar(void);
extern char *ogets(char *s, int len, obj_t oid);
 



extern char *getstrn(char *s, int len);

extern int fclose(FILE *stream);
extern FILE *fdopen(int fildes, const char *type);
extern int feof(FILE *stream);
extern int ferror(FILE *stream);
extern int fflush(FILE *stream);
extern int fgetc(FILE *stream);
extern int fgetpos(FILE *stream, fpos_t *pos);
extern char *fgets(char *s, int n, FILE *stream);
extern int fileno(FILE *stream);
extern FILE *fopen(const char *filename, const char *mode);
extern int fprintf(FILE *stream, const char *fmt, ...);
extern int fputc(int c, FILE *stream);
extern int putc(int c, FILE *stream);
extern int fputs(const char *s, FILE *stream);
extern size_t fread(void *ptr, size_t size, size_t nelem, FILE *stream);
extern FILE *freopen(const char *filename, const char *mode, FILE *stream);
extern int fscanf(FILE *stream, const char *format, ...);
extern int fseek(FILE *stream, long offset, int whence);
extern int fsetpos(FILE *stream, const fpos_t *pos);
extern long ftell(FILE *stream);
extern size_t fwrite(const void *ptr, size_t size, size_t nelem, FILE *stream);

extern void perror(const char *msg);
extern void print_error(const char *msg, ulong errcode);


# 49 "drv/tty.c" 2

# 1 "include/dir.h" 1
 

















































extern obj_t dir_parse(obj_t cwd, char *path);
extern obj_t dir_parse_path(obj_t cwd, char *path, char *buf, boolean make);
extern obj_t dir_create(obj_t cwd, char *path, obj_t val);
extern obj_t dir_mkdir(obj_t cwd, char *name);




# 50 "drv/tty.c" 2

# 1 "include/event.h" 1
 












































 















 















 














# 51 "drv/tty.c" 2






typedef struct {
	obj_t	bufin;
	obj_t	bufout;
	ushort	iflag;
	ushort	oflag;
	ushort	lflag;
	ushort	wid;
	ushort	hgt;
	obj_t	thread;
	uchar	cc[13 ];
	ushort	ipos;
	uchar	ibuf[256 ];
} TTY;

 




















 















extern label_t _icrnl, _inlcr, _igncr, _iflag;
extern label_t _ocrnl, _onlcr, _onocr, _onlret, _oflag;
extern label_t _echo, _echoe, _echok, _echonl, _icanon, _isig, _lflag;
extern label_t _thread, _wid, _hgt, _stdin, _stdout;
extern label_t _msleep, _signal, _suspend, _parent;

static obj_t tty_init(ObjFrame *frame, TTY *tty)
{
	frame->data = tty = (TTY*)ObjCall_Trap ((obj_t)(((ulong)( 0x8  ) << 28) | ((ulong)(  0x0fffffff -2 ) & 0x0fffffff ))  , _mem_alloc, sizeof(TTY), (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
	frame->size = sizeof(TTY);
	tty->cc[0 ] = (( 'D' )-64) ; 
	tty->cc[1 ] = (( 'J' )-64) ;
	tty->cc[2 ] = (( 'H' )-64) ;
	tty->cc[9 ] = 127;
	tty->cc[3 ] = (( 'C' )-64) ;
	tty->cc[4 ] = (( 'U' )-64) ;
	tty->cc[5 ] = (( '\\' )-64) ;
	tty->cc[6 ] = (( 'Z' )-64) ;
	tty->cc[7 ] = (( 'Q' )-64) ;
	tty->cc[8 ] = (( 'S' )-64) ;
	tty->cc[10 ] = (( 'V' )-64) ;
	tty->cc[11 ] = (( 'W' )-64) ;
	tty->cc[12 ] = (( 'R' )-64) ;
	tty->wid = 80;
	tty->hgt = 24;
	tty->iflag = (1 << ( 0  )) ;
	tty->oflag = (1 << ( 1  )) ;
	tty->lflag = (1 << ( 4  )) | (1 << ( 0  )) | (1 << ( 5  )) ;

	tty->thread = (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))  ;
	tty->ipos = 0;
	return(0x80 | 0x01 );
}

static obj_t tty_read(ObjFrame *frame, TTY *tty, uchar *buf, int len)
{
	if(tty->iflag & (1 << ( 14  )) ) {
		tty->iflag &= ~(1 << ( 14  )) ;
		return((obj_t)(((ulong)( 0xe  ) << 28) | ((ulong)(  0x23  ) & 0x0fffffff ))   );
	}
	return(ObjCall (tty->bufin,_read,(obj_t)( buf ) ,len,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   ));
}


static void tty_clearchar(TTY *tty, char ch)
{
	if(!(tty->lflag & (1 << ( 0  )) ))
		return;
	if(ch < 32)
		ObjCall (tty->bufout,_write,(obj_t)( "\b\b  \b\b" ) ,6,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
	else
		ObjCall (tty->bufout,_write,(obj_t)( "\b \b" ) ,3,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
}

static void tty_writechar(TTY *tty, char ch)
{
char cb[2];
	if(!(tty->lflag & (1 << ( 0  )) ))
		return;
	if(ch < 32 && ch != 9) {
		cb[0] = '^';
		cb[1] = ch+64;
		ObjCall (tty->bufout,_write,(obj_t)( cb ) ,2,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
	} else 
		ObjCall (tty->bufout,_write,(obj_t)( &ch ) ,1,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
}

static void tty_writebuf(TTY *tty)
{
int n = 0;
	while(n < tty->ipos) 
		tty_writechar(tty,tty->ibuf[n++]);
}

static void tty_clearline(TTY *tty)
{
int n = tty->ipos;
	while(n > 0) {
		n--;
		tty_clearchar(tty,tty->ibuf[n]);
	}
}


static obj_t tty_write(ObjFrame *frame, TTY *tty, uchar *buf, int len)
{
uchar cb[2048];
int i, count;
uchar ch;
	tty_clearline(tty);
	i = 0;
	count = 0;	
	while(len-- > 0) {
		ch = *buf++;
		if(ch == '\r' && (tty->oflag & (1 << ( 0  )) )) {
			cb[i++] = '\n';
		} else if(ch == '\n' && (tty->oflag & (1 << ( 1  )) )) {
			cb[i++] = '\r';
			cb[i++] = '\n';
		} else
			cb[i++] = ch;
		count++;
		while(tty->oflag & (1 << ( 15  )) )
			ObjCall_Trap ((obj_t)(((ulong)( 0x8  ) << 28) | ((ulong)(  0x0fffffff -3 ) & 0x0fffffff ))  , _msleep, 0, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
		if(!len || i > sizeof(cb)-2) {
			ObjCall (tty->bufout,_write,(obj_t)( cb ) ,i,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
			i = 0;
		}
	}
	tty_writebuf(tty);
	return(count);
}

static obj_t tty_devread(ObjFrame *frame, TTY *tty, uchar *buf, int len)
{
	return(ObjCall (tty->bufout,_read,(obj_t)( buf ) ,len,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   ));
}

static obj_t tty_devwrite(ObjFrame *frame, TTY *tty, uchar *buf, int len)
{
int count;
uchar ch;
	count = 0;
	while(len-- > 0) {
		count++;
		ch = *buf++;
		if((tty->lflag & (1 << ( 5  )) ) && tty->thread != (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))  ) {
			if(ch == tty->cc[6 ]) {
				obj_t parent = ObjCall_Trap (tty->thread, _get, _parent,
						  (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
				ObjCall_Trap (tty->thread, _suspend, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
				ObjCall_Trap (parent, _signal, 0x00020000 ,
						 tty->thread, tty->thread);
				ObjCall (tty->bufout,_write,(obj_t)( "^Z\r\n" ) ,4,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
				continue;
			} 
			if(ch == tty->cc[3 ]) {
				ObjCall_Trap (tty->thread, _free, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   , (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
				continue;
			}
		}
		if(!(tty->lflag & (1 << ( 4  )) )) {
			ObjCall (tty->bufin,_write,(obj_t)( &ch ) ,1,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
			continue;
		}	
		if(tty->iflag & (1 << ( 15  )) ) {
			tty->iflag &= ~(1 << ( 15  )) ;
			tty->ibuf[tty->ipos++] = ch;
			tty_writechar(tty, ch);
			continue;
		}
		if(ch == '\n' && (tty->iflag & (1 << ( 1  )) ))
			ch = '\r';
		if(ch == '\r' && (tty->iflag & (1 << ( 0  )) ))
			ch = '\n';
		if(ch == tty->cc[2 ] || ch == tty->cc[9 ] ||
		   ch == tty->cc[11 ] || ch == tty->cc[4 ]) {	
			while(tty->ipos > 0) {
				tty->ipos--;
				tty_clearchar(tty, tty->ibuf[tty->ipos]);
				if(ch == tty->cc[2 ] ||
				   ch == tty->cc[9 ] ||
				   (ch == tty->cc[11 ] &&
					(tty->ipos == 0 || 
					 tty->ibuf[tty->ipos-1] <= 32)))
					break;
			}
		} else if(ch == tty->cc[12 ]) {
			ObjCall_Trap (tty->bufout, _write, (obj_t)( "\r\n" ) , 2, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
			tty_writebuf(tty);
		} else if(ch == tty->cc[1 ]) {
			tty->ibuf[tty->ipos++] = ch;
			ObjCall_Trap (tty->bufin, _write, (obj_t)( tty->ibuf ) , tty->ipos, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
			tty->ipos = 0;
			if(tty->lflag & ((1 << ( 3  )) | (1 << ( 0  )) ))
				ObjCall_Trap (tty->bufout, _write, (obj_t)( "\r\n" ) , 2, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
		} else if(ch == tty->cc[0 ]) {	
			tty->iflag |= (1 << ( 14  )) ;
			ObjCall_Trap (tty->bufin, _write, (obj_t)( "\n" ) , 1, (obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
			tty->ipos = 0;
		} else if(ch == tty->cc[8 ]) {
			tty->oflag |= (1 << ( 15  )) ;
		} else if(ch == tty->cc[7 ]) {
			tty->oflag &= ~(1 << ( 15  )) ;
		} else if(ch == tty->cc[10 ]) {
			tty->iflag |= (1 << ( 15  )) ;
		} else {
			tty->ibuf[tty->ipos++] = ch;
			tty_writechar(tty, ch);
		}
	}
	return(count);
}

static MethodTable tty_method[] = {
	{&_init,(obj_method)tty_init},
	{&_read,(obj_method)tty_read},
	{&_write,(obj_method)tty_write},
	{&_devread,(obj_method)tty_devread},
	{&_devwrite,(obj_method)tty_devwrite}};

AttrTable tty_attr[] = {
	{&_stdin,((size_t)(&(( TTY *)0)-> bufin )) ,0x07 },
	{&_stdout,((size_t)(&(( TTY *)0)-> bufout )) ,0x07 },
	{&_icrnl,((size_t)(&(( TTY *)0)-> iflag )) ,0x20 | 0 },
	{&_inlcr,((size_t)(&(( TTY *)0)-> iflag )) ,0x20 | 1 },
	{&_igncr,((size_t)(&(( TTY *)0)-> iflag )) ,0x20 | 2 },
	{&_iflag,((size_t)(&(( TTY *)0)-> iflag )) ,0x06 },
	{&_ocrnl,((size_t)(&(( TTY *)0)-> oflag )) ,0x20 | 0 },
	{&_onlcr,((size_t)(&(( TTY *)0)-> oflag )) ,0x20 | 1 },
	{&_onlret,((size_t)(&(( TTY *)0)-> oflag )) ,0x20 | 2 },
	{&_onocr,((size_t)(&(( TTY *)0)-> oflag )) ,0x20 | 3 },
	{&_oflag,((size_t)(&(( TTY *)0)-> oflag )) ,0x06 },
	{&_echo,((size_t)(&(( TTY *)0)-> lflag )) ,0x20 | 0 },
	{&_echoe,((size_t)(&(( TTY *)0)-> lflag )) ,0x20 | 1 },
	{&_echok,((size_t)(&(( TTY *)0)-> lflag )) ,0x20 | 2 },
	{&_echonl,((size_t)(&(( TTY *)0)-> lflag )) ,0x20 | 3 },
	{&_icanon,((size_t)(&(( TTY *)0)-> lflag )) ,0x20 | 4 },
	{&_isig,((size_t)(&(( TTY *)0)-> lflag )) ,0x20 | 5 },
	{&_lflag,((size_t)(&(( TTY *)0)-> lflag )) ,0x06 },
	{&_wid,((size_t)(&(( TTY *)0)-> wid )) ,0x04 },
	{&_hgt,((size_t)(&(( TTY *)0)-> hgt )) ,0x04 },
	{&_thread,((size_t)(&(( TTY *)0)-> thread )) ,0x07 }};

static ObjClass Class_TTY = {
	tty_method,
	tty_attr,
	(sizeof( tty_method )/sizeof(*( tty_method ))) ,
	(sizeof( tty_attr )/sizeof(*( tty_attr ))) };
 

obj_t Main(ObjFrame *frame, vaddr base, obj_t arg, obj_t env)
{
obj_t class_object;
obj_t class_tty;
	cprintf("Terminal Driver  v0.01  Nov 1992\n");
	class_object = dir_parse((obj_t)(((ulong)( 0x8  ) << 28) | ((ulong)(  0x0fffffff -4 ) & 0x0fffffff ))  , "/class/Object");
	class_tty = ObjCall_Trap (class_object, _class, (obj_t)( &Class_TTY ) ,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   ,(obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
	dir_create((obj_t)(((ulong)( 0x8  ) << 28) | ((ulong)(  0x0fffffff -4 ) & 0x0fffffff ))  ,"/class/TTY", class_tty);
	return((obj_t)(((ulong)( 0xd  ) << 28) | ((ulong)( 0x00 ) & 0x0fffffff ))   );
}

