
%{
int yyerror(const char *str, ...);
int yylex(int *yylval);
int yydebug = 1;
//#define YYPDEBUG
%}

%token ADD SUB
%token MUL DIV
%token NUM
%token ID

%%

start: expr;

mulexpr:
	  primary
	| mulexpr MUL primary
	| mulexpr DIV primary
	;

addexpr:
	  mulexpr
	| addexpr ADD mulexpr
	| addexpr SUB mulexpr
	;

expr: addexpr;

primary: id | lit;

lit: NUM;

id: ID;



%%

struct { int tok; int val; } inp[] = {
	ID,'a',  ADD,0, ID,'b',  MUL,0, NUM,42
};
int ntok = sizeof(inp)/sizeof(*inp);
int tnum = 0;

int
yyerror(const char *str, ...)
{
	printf("yyerror: %s\n", str);
}

int
yylex(int *yylval)
{
	if(tnum < ntok) {
		*yylval = inp[tnum].val;
		return inp[tnum++].tok;
	} else
		return 0;
}

main()
{
	yyparse();
}

