
%{
int yyerror(const char *str);
int yylex(int *yylval);
int yydebug = 1;
%}

%token ADD SUB
%token MUL DIV
%token NUM
%token ID

%%

start: amb;

amb: p1 | p2 | primary;

p1: primary ADD amb;

p2: primary MUL amb;

primary: id | num;

id: ID;

num: NUM;

%%

struct { int tok; int val; } inp[] = {
	ID,'a',  ADD,0, ID,'b',  MUL,0, NUM,42
};
int ntok = sizeof(inp)/sizeof(*inp);
int tnum = 0;

int
yyerror(const char *str)
{
	printf("yyerror: %s\n", str);
}

int
yylex(int *yylval)
{
	if(tnum < ntok) {
		*yylval = inp[tnum].val;
		return inp[tnum++].tok;
	} else
		return 0;
}

main()
{
	yyparse();
}

